package com.peup.dao;

import java.util.List;
import java.util.Map;

public interface IGenericDao<T> {

	/**
	 * Method that returns the number of entries from a table that meet some
	 * criteria (where clause params)
	 * 
	 * @param params
	 *            sql parameters
	 * @return the number of records meeting the criteria
	 */
	long countAll(Map<String, Object> params);

	T create(T t);

	void delete(Object id);

	T find(Object id);
	List<T> find(Map<String, Object> params);
	T update(T t);
	
}