package com.peup.listener;
import org.apache.log4j.Logger;
import org.springframework.batch.core.BatchStatus;
import org.springframework.batch.core.JobExecution;
import org.springframework.batch.core.JobExecutionListener;

import com.peup.AppPeup;
import com.peup.service.util.SpringPropertiesUtil;
import com.peup.service.util.UtilGenerateCsv;

public class AppJobExecutionListener implements JobExecutionListener {

	private final static Logger logger = Logger
			.getLogger(AppJobExecutionListener.class);

	public void afterJob(JobExecution jobExecution) {
		if (jobExecution.getStatus() == BatchStatus.COMPLETED) {
			logger.info("Job completed: " + jobExecution.getJobId());
			logger.info("Job name completed: " + jobExecution.getJobInstance().getJobName());
		} else if (jobExecution.getStatus() == BatchStatus.FAILED) {
			logger.info("Job id failed: " + jobExecution.getJobId());
			logger.info("Job name failed: " + jobExecution.getJobInstance().getJobName());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_ID, jobExecution.getJobId());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_NAME, jobExecution.getJobInstance().getJobName());			
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_EXIT_STATUS, jobExecution.getExitStatus().getExitCode());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_EXIT_DESCRIPTION, jobExecution.getExitStatus().getExitDescription());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_START_TIME, jobExecution.getStartTime());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_END_TIME, jobExecution.getEndTime());
			UtilGenerateCsv.generateCsvFile(SpringPropertiesUtil.getProperty("file.output.log"),AppPeup.MESSAGESLOG);
		}
	}

	public void beforeJob(JobExecution jobExecution) {
		if (jobExecution.getStatus() == BatchStatus.COMPLETED) {
			logger.info("Job completed: " + jobExecution.getJobId());
			logger.info("Job name completed: " + jobExecution.getJobInstance().getJobName());
		} else if (jobExecution.getStatus() == BatchStatus.FAILED) {
			logger.info("Job id failed: " + jobExecution.getJobId());
			logger.info("Job name failed: " + jobExecution.getJobInstance().getJobName());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_ID, jobExecution.getJobId());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_NAME, jobExecution.getJobInstance().getJobName());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_EXIT_STATUS, jobExecution.getExitStatus().getExitCode());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_EXIT_STATUS, jobExecution.getExitStatus().getExitDescription());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_START_TIME, jobExecution.getStartTime());
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.JOB_END_TIME, jobExecution.getEndTime());
			UtilGenerateCsv.generateCsvFile(SpringPropertiesUtil.getProperty("file.output.log"),AppPeup.MESSAGESLOG);
		}
	}

}