package com.peup.listener;

import org.apache.log4j.Logger;
import org.springframework.batch.core.ItemReadListener;

import com.peup.AppPeup;
import com.peup.dto.DossierRedevableDto;
import com.peup.service.util.UtilGenerateCsv;

public class CustomItemReaderListener implements ItemReadListener<Object> {
	private final static Logger logger = Logger
			.getLogger(CustomItemReaderListener.class);

	public void beforeRead() {
		logger.info("ItemReadListener - beforeRead");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "beforeRead");
	}

	public void afterRead(Object item) {
		DossierRedevableDto dossierRedevableDto = (DossierRedevableDto) item;
		logger.info("ItemReadListener - afterRead");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "afterRead");

		if (dossierRedevableDto != null) {
			if (dossierRedevableDto.getDossierId() != null) {
				AppPeup.MESSAGESLOG.put(UtilGenerateCsv.DOSSIER_ID,
						dossierRedevableDto.getDossierId());
			}// if
			if (dossierRedevableDto.getRedevableId() != null) {
				AppPeup.MESSAGESLOG.put(UtilGenerateCsv.REDEVABLE_ID,
						String.valueOf(dossierRedevableDto.getRedevableId()));
			}// if

			if (dossierRedevableDto.getAdresse() != null) {
				AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ADRESSE,
						String.valueOf(dossierRedevableDto.getAdresse()));
			}// if
			if (dossierRedevableDto.getCodeSiret() != null) {
				AppPeup.MESSAGESLOG.put(UtilGenerateCsv.CODE_SIRET,
						dossierRedevableDto.getCodeSiret());
			}// if
		}
	}

	public void onReadError(Exception ex) {
		logger.info("ItemReadListener - onReadError");
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, ex.getMessage());
	}

}
