package com.peup.listener;

import org.apache.log4j.Logger;
import org.springframework.batch.core.listener.ItemListenerSupport;

import com.peup.AppPeup;
import com.peup.service.util.UtilGenerateCsv;

public class ItemFailureLoggerListener extends ItemListenerSupport {
	private final static Logger logger = Logger
			.getLogger(ItemFailureLoggerListener.class);

	public void onReadError(Exception ex) {
		logger.error("Encountered error on read", ex);
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR,ex.getMessage());
	}

	public void onWriteError(Exception ex, Object item) {
		logger.error("Encountered error on write", ex);
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR,ex.getMessage());
	}
	
	
	public void onProcessError(Exception ex, Object item) {
		logger.error("Encountered error on process", ex);
		AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR,ex.getMessage());
	}
}
