package com.peup.service.util;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Transparency;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;

import javax.imageio.ImageIO;
import javax.swing.ImageIcon;

import org.apache.log4j.Logger;
import org.im4java.core.ConvertCmd;
import org.im4java.core.IM4JavaException;
import org.im4java.core.IMOperation;
import org.im4java.core.Stream2BufferedImage;

import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

//import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;

public class URLUtils {
	private final static Logger logger = Logger.getLogger(URLUtils.class);

	public static String addParameter(String URL, String name, String value) {
		int qpos = URL.indexOf('?');
		int hpos = URL.indexOf('#');
		char sep = qpos == -1 ? '?' : '&';
		String seg = sep + encodeUrl(name) + '=' + encodeUrl(value);
		return hpos == -1 ? URL + seg : URL.substring(0, hpos) + seg
				+ URL.substring(hpos);
	}

	/**
	 * The same behaviour as Web.escapeUrl, only without the "funky encoding" of
	 * the characters ? and ; (uses JDK URLEncoder directly).
	 * 
	 * @param toencode
	 *            The string to encode.
	 * @return <code>toencode</code> fully escaped using URL rules.
	 */
	public static String encodeUrl(String url) {
		try {
			return URLEncoder.encode(url, "UTF-8");
		} catch (UnsupportedEncodingException uee) {
			throw new IllegalArgumentException(uee);
		}
	}

	public static boolean existsURL(String URLName) {

		logger.info("check file exist:" + URLName);
		boolean testValid = false;
		try {
			HttpURLConnection.setFollowRedirects(false);
			// note : you may also need
			// HttpURLConnection.setInstanceFollowRedirects(false)
			HttpURLConnection con = (HttpURLConnection) new URL(URLName)
					.openConnection();
			con.setRequestMethod("HEAD");
			con.setConnectTimeout(Integer.valueOf(SpringPropertiesUtil.getProperty("timeout.connect"))); //set timeout n milliSeconds
			con.setReadTimeout(Integer.valueOf(SpringPropertiesUtil.getProperty("timeout.socket")));
			
			con.setRequestProperty("User-Agent",
					"Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)");
			con.setUseCaches(false);
			con.setDoInput(true);
			con.setDoOutput(true);

			logger.info("result:"
					+ (con.getResponseCode() == HttpURLConnection.HTTP_OK)
					+ "\n Server returned HTTP response code: "
					+ con.getResponseCode());
			testValid = (con.getResponseCode() == HttpURLConnection.HTTP_OK);
		} catch (Exception e) {
			logger.info("error:" + e.toString());
			e.printStackTrace();
			return false;
		}

		// ----test valid image-----------
		if (!isImage(URLName))
			return false;
		return testValid;
	}

	synchronized public static String getJpeg64(String URLImage) {
		logger.info("--------------------------Debut traitement convertion png,gif,tif,bmp to jpeg---------------------------------------");
		logger.info("URLImage:" + URLImage);
		BufferedImage inputImage = null;

		ByteArrayOutputStream baos = new ByteArrayOutputStream();//Integer.parseInt(SpringPropertiesUtil.getProperty("size.max.image")));
		String base64String = null;
		// read PNG image as BufferedImage
		try {
			inputImage = ImageIO.read(new URL(URLImage));
			if (inputImage.getColorModel().getTransparency() != Transparency.OPAQUE) {
				inputImage = fillTransparentPixels(inputImage, Color.WHITE);
			}
			// JPG output
			ImageIO.write(inputImage, "jpg", baos);
			baos.flush();
			base64String = Base64.encode(baos.toByteArray());
			baos.close();
		} catch (IOException e) {
			logger.info("error:" + e.toString());
		}
//		System.gc();
		return base64String;

	}
	
//	public static String getJpeg64(String URLImage) {
//		logger.info("--------------------------Debut traitement convertion png,gif,tif,bmp to jpeg---------------------------------------");
//		logger.info("URLImage:" + URLImage);
//		String base64String = null;
////		BufferedImage inputImage = null;
//		try {
//			// create the a jpg image
//			ConvertCmd cmd = new ConvertCmd();
//			// create the operation, add images and operators/options
//			IMOperation op = new IMOperation();
////			inputImage = ImageIO.read(new URL(URLImage));        
//	        		
//			op.addImage();
//			op.format("jpg");
//			op.composite();
//			op.background("white");
//			// op.addImage(imageLocation);
//			// op.transparent();
//			// execute the operation
//			Stream2BufferedImage s2b = new Stream2BufferedImage();
//			cmd.setOutputConsumer(s2b);
//			cmd.run(op,convertImageBuff(URLImage));
//			BufferedImage img = s2b.getImage();
//			byte[] imageBytes = ((DataBufferByte) img.getData().getDataBuffer())
//					.getData();
//			base64String = Base64.encode(imageBytes);
//
//		} catch (IOException e) {
//			logger.info("error:" + e.toString());
//		} catch (InterruptedException e) {
//			logger.info("error:" + e.toString());
//		} catch (IM4JavaException e) {
//			logger.info("error:" + e.toString());
//		}
//		return base64String;
//	}
	
	public static BufferedImage convertImageBuff(String imgUrl){
		ImageIcon icon = null;
		BufferedImage b=null;
		try {
		URL url = new URL(imgUrl);
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		byte buffer[] = new byte[1024];
		int len = -1;
		InputStream is = url.openStream();
		while((len = is.read(buffer)) != -1) {
		baos.write(buffer, 0, len);
		}
		icon = new ImageIcon(baos.toByteArray());
		} catch (Exception e) {
		e.printStackTrace();
		}
		b = new BufferedImage(icon.getIconWidth(), icon.getIconHeight(), BufferedImage.TYPE_INT_ARGB);		
		return b;
		
	}
	
//	public static BufferedImage getresolution(BufferedImage oldimage){
////		BufferedImage oldimage = ImageIO.read(newfile);
////		BufferedImage tmp = Scalr.rotate(oldimage, Orientation);
////		oldimage.flush();
////		oldimage=tmp;
//		Iterator iter = ImageIO.getImageWritersByFormatName("jpeg");
//		ImageWriter writer = (ImageWriter)iter.next();
//		ImageWriteParam iwp = writer.getDefaultWriteParam();
//		iwp.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
//		float quality=1.0f;
//		iwp.setCompressionQuality(quality);
//
////		FileImageOutputStream output = new FileImageOutputStream(newfile);
////		writer.setOutput(output);
//
//		IIOImage image = new IIOImage(oldimage, null, null);
//		writer.write(null, image, iwp);
//		//writer.dispose();
//		//output.close();
//		
//	}
//	public static String getJpeg64_2(String URLImage) {
//		logger.info("--------------------------Debut traitement convertion png,gif,tif,bmp to jpeg---------------------------------------");
//		logger.info("URLImage:" + URLImage);
//		BufferedImage inputImage = null;
//
//		ByteArrayOutputStream baos = new ByteArrayOutputStream(Integer.parseInt(SpringPropertiesUtil.getProperty("size.max.image")));
//		String base64String = null;
//		// read PNG image as BufferedImage
//		try {
//			inputImage = ImageIO.read(new URL(URLImage));
//			if (inputImage.getColorModel().getTransparency() != Transparency.OPAQUE) {
//				inputImage = fillTransparentPixels(inputImage, Color.WHITE);
//			}
//			
//			// JPG output
//			ImageIO.write(inputImage, "jpg", baos);
//			baos.flush();
//			base64String = Base64.encode(baos.toByteArray());
//			baos.close();
//		} catch (IOException e) {
//			logger.info("error:" + e.toString());
//		}
//		System.gc();
//		return base64String;
//
//	}
	
	
	

	synchronized public static BufferedImage fillTransparentPixels(BufferedImage image,
			Color fillColor) {
		int w = image.getWidth();
		int h = image.getHeight();
		BufferedImage image2 = new BufferedImage(w, h,
				BufferedImage.TYPE_INT_RGB);
		Graphics2D g = image2.createGraphics();
		g.setColor(fillColor);
		g.fillRect(0, 0, w, h);
		g.drawRenderedImage(image, null);
		g.dispose();
		return image2;
	}
	
	public static boolean isImage(String URLImage){
		logger.info("---------------check file isImage:" + URLImage);
		BufferedImage inputImage = null;
		boolean valid=true;
		try {
			inputImage = ImageIO.read(new URL(URLImage));
		    if (inputImage == null) {
		        valid = false;
		        logger.info("The file:"+URLImage+"could not be opened , it is not an image");
		    }
		} catch(IOException ex) {
		    valid=false;
		       logger.info("The file:"+URLImage+"could not be opened , an error occurred.");
		}
		return valid;
	}
	
	

}
