package com.peup.service.util;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.io.FileUtils;
import org.apache.log4j.Logger;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Entities.EscapeMode;
import org.springframework.core.io.Resource;

import com.peup.AppPeup;

public class UtilService {
	private final static Logger logger = Logger.getLogger(UtilService.class);
	public static String DateBegin;
	public static long lStartTime;
	public static long lEndTime;

	public static final int STATUT_NOT_VALID = 0;
	public static final int STATUT_VALID = 1;

	private static SimpleDateFormat dateFormat = new SimpleDateFormat(
			"yyyy-MM-dd HH:mm:ss");

	static DateTimeFormatter fmt = DateTimeFormat
			.forPattern("yyyy_MM_dd_HH_mm_ss");
	static DateTimeFormatter fmt2 = DateTimeFormat
			.forPattern("yyyyMMddHHmmssSSS");
	private static SimpleDateFormat dateFormat2 = new SimpleDateFormat(
			"yyyy/MM/dd-HH:mm:ss");
	private static SimpleDateFormat dateFormat3 = new SimpleDateFormat(
			"yyyy-MM-dd");

	static DecimalFormat decimalFormat = (DecimalFormat) DecimalFormat
			.getInstance();

	public static String convertLatin(String your_string)
			throws UnsupportedEncodingException {
		return new String(your_string.getBytes(), "ISO-8859-15");
	}

	public static Calendar dateToCalendar(Date date) {
		Calendar cal = Calendar.getInstance();
		cal.setTime(date);
		return cal;
	}

	public static String convertUtf8(String your_string)
			throws UnsupportedEncodingException {
		return new String(your_string.getBytes(), "UTF-8");
	}

	public static Date convertStringToDate(String dateOfReception)
			throws ParseException {
		return dateFormat.parse(dateOfReception);
	}

	public static Timestamp convertStringToTimeStamp(String dateOfReception)
			throws ParseException {
		Timestamp timestamp = null;
		try {
			// SimpleDateFormat dateFormat = new
			// SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
			Date parsedDate = dateFormat.parse(dateOfReception);
			timestamp = new java.sql.Timestamp(parsedDate.getTime());
		} catch (Exception e) {// this generic but you csan control another
								// types of exception

		}
		return timestamp;

	}

	public static Date getCurrentDateTime() {
		return new java.util.Date();
	}

	public static Timestamp getCurrentTimeStamp() {
		java.util.Date date = new java.util.Date();
		return new Timestamp(date.getTime());
	}

	public static String getCurrentDate() {

		Calendar cal = Calendar.getInstance();
		return dateFormat.format(cal.getTime());
	}

	public static String getCurrentDate2() {
		Calendar cal = Calendar.getInstance();
		return fmt2.print(cal.getTime().getTime());
	}

	public static String getCurrentDateForFolder() {
		DateTimeFormatter fmt2 = DateTimeFormat.forPattern("yyyyMMdd");
		Calendar cal = Calendar.getInstance();
		return fmt2.print(cal.getTime().getTime());
	}

	public static byte[] getByteFromURL(InputStream input) throws IOException {

		ByteArrayOutputStream output = new ByteArrayOutputStream();
		byte[] buffer = new byte[Integer.valueOf(SpringPropertiesUtil
				.getProperty("buffer.size"))];
		int l;
		while ((l = input.read(buffer)) > 0)
			output.write(buffer, 0, l);
		input.close();
		byte[] pdfBytes = output.toByteArray();

		return pdfBytes;
	}

	public static Resource getByteFromFile(String fileURL) {
		return ApplicationContextUtils.getApplicationContext().getResource(
				"file:" + fileURL);
	}

	public static void writeFileUtf8(String content, String fileName,String outFolder) {
		String url = new String(outFolder+"/"+fileName);
		try {
			File fileDir = new File(url);

				
			
			FileUtils.writeStringToFile(fileDir, content, "UTF-8");			

		} catch (IOException e) {			
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.STEP_NAME, "onSkipInWrite");
			AppPeup.MESSAGESLOG.put(UtilGenerateCsv.ERROR, e.getMessage());

			UtilGenerateCsv.generateCsvFile(
					SpringPropertiesUtil.getProperty("file.output.log"),
					AppPeup.MESSAGESLOG);
		}
		
	}



	public static void beginTaskTime() {
		lStartTime = new Date().getTime();
		Calendar cal = Calendar.getInstance();
		DateBegin = dateFormat2.format(cal.getTime());
	}

	public static float getElaspedTimeSec() {
		lEndTime = new Date().getTime();

		// decimalFormat.applyPattern("#0.######");
		float f = lEndTime - lStartTime;
		f = f / 1000;
		// logger.debug(decimalFormat.format(f));

		return f;
		// DoubleFormatter df = new DoubleFormatter(4,6); //4 = MaxInteger, 6 =
		// MaxDecimal
		// decimalFormat.applyPattern("#0.########");
		// String beautyDisplay = decimalFormat.format(f);
		// BigDecimal.
		// return beautyDisplay;
	}

	public static String clean(String html) {
		Document doc = Jsoup.parse(html);
		doc.outputSettings().escapeMode(EscapeMode.xhtml);
		doc.outputSettings().charset("utf-8");
		return doc.toString();
	}

//	public static String getDirFolder(long id) {
//		return SpringPropertiesUtil.getProperty("folder.output")
//				+ String.format(SpringPropertiesUtil
//						.getProperty("format.folder.name.out"), id);
//	}

	public final static boolean createFolder(String dir) {
		File directory = new File(dir);
		if (directory.exists())
			return false;
		return directory.mkdir();
	}

	private final static Pattern unescapedAmpersands = Pattern
			.compile("(&(?!amp;))");

	public static String cleanURL(String xml) {
		// clean
		Matcher m = unescapedAmpersands.matcher(xml);
		return m.replaceAll("&amp;");
	}

	// Pour la gestion des dates
	public static String formateHeure(java.util.Date uneDate) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyy-MM-dd HH:mm");
		return (uneDate != null) ? sdf.format(uneDate) : "";
	}

	public static String formateHeureMinuteSeconde(java.util.Date uneDate) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"hh'h'mm'm'ss's'");
		return sdf.format(uneDate);
	}

	public static String formateDate(java.util.Date uneDate) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyy-MM-dd");
		return sdf.format(uneDate);
	}

	public static String formateDateArgus(java.util.Date uneDate) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyy/MM/dd-HH:mm:ss");
		return sdf.format(uneDate);
	}

	public static String formateDateCrawl(java.sql.Timestamp uneDateTimestamp) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyy/MM/dd-HH:mm:ss");
		java.util.Date uneDate = new java.util.Date();
		//uneDate.setTime(uneDateTimestamp.getTime());

		return sdf.format(uneDateTimestamp);
	}
	public static String formateDateCrawl2(java.sql.Timestamp uneDateTimestamp) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyy-MM-dd HH:mm:ss.SSS");
		java.util.Date uneDate = new java.util.Date();
		//uneDate.setTime(uneDateTimestamp.getTime());

		return sdf.format(uneDateTimestamp);
	}

	public static String formateDateJolie(java.util.Date uneDate) {
		return java.text.DateFormat.getDateInstance(java.text.DateFormat.LONG)
				.format(uneDate);
	}

	// --------------------------------
//	public static String formateDatePdf(java.util.Date uneDate) {
//		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
//				"dd/MM/yyyy");
//		return sdf.format(uneDate);
//	}
	public static String formateDatePdf(java.sql.Timestamp uneDateTimestamp) {
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"dd/MM/yyyy");
		return sdf.format(uneDateTimestamp);
	}
	
	// --------------------------------

	public static void fileDelete(String fileName) {
		File f = new File(fileName);
		// Make sure the file or directory exists and isn't write protected
		if (!f.exists()) {
			logger.debug("Delete: no such file or directory: " + fileName);
			return;
		}

		if (!f.canWrite())
			logger.debug("Delete: write protected: " + fileName);

		// If it is a directory, make sure it is empty
		if (f.isDirectory()) {
			String[] files = f.list();
			if (files.length > 0)
				logger.debug("Delete: directory not empty: " + fileName);
		}

		// Attempt to delete it
		boolean success = f.delete();

		if (!success)
			logger.debug("Delete: deletion failed");
	}

	public static void fileRename(String fileNameUrl, String fileRenameUrl) {
		File f = new File(fileNameUrl);
		// Make sure the file or directory exists and isn't write protected
		if (!f.exists()) {
			logger.debug("Rename: no such file or directory: " + fileNameUrl);
			return;
		}// file

		if (!f.canWrite())
			logger.debug("Delete: write protected: " + fileNameUrl);

		// If it is a directory, make sure it is empty
		if (f.isDirectory()) {
			String[] files = f.list();
			if (files.length > 0)
				logger.debug("Rename: directory not empty: " + fileNameUrl);
		}

		//erase 
		File f2 = new File(fileRenameUrl);
		if (f2.exists()){
			f2.delete();
		}
			
		// Attempt to delete it
		boolean success = f.renameTo(new File(fileRenameUrl));

		if (!success)
			logger.debug("Delete: Rename failed");
	}
	
	
	public static boolean fileCopy(String inputFileUrl, String outputFileUrl)
			throws IOException {

		File inputFile = new File(inputFileUrl);
		File outputFile = new File(outputFileUrl);
		try {
		    FileUtils.copyFile(inputFile, outputFile);
		} catch (IOException e) {
		   logger.info(e);
		   return true;
		}
		return true;
	}

	public static boolean fileExist(String fileName) {
		File file = new File(fileName);
		if (file.exists())
			return true;
		return false;

	}
	public static boolean directoryExist(String fileName) {
		File file = new File(fileName);
		if (file.exists() && file.isDirectory())
			return true;
		return false;
	}

	public static void rmDir(final File folder) {
		// check folder exist
		if (folder==null || !folder.exists()) {
			logger.debug("RmDir: no such file or directory: " + folder);
			return;
		}
		// check if folder file is a real folder
		if (folder.isDirectory()) {
			File[] list = folder.listFiles();
			if (list != null) {
				for (int i = 0; i < list.length; i++) {
					File tmpF = list[i];
					if (tmpF.isDirectory()) {
						rmDir(tmpF);
					}
					tmpF.delete();
				}
			}
			if (!folder.delete()) {
				logger.debug("can't delete folder : " + folder);
			}
		}
	}


}
