package com.peup.tasks;

import com.peup.dto.SiretXY;

import java.io.*;

import java.util.ArrayList;
import java.util.List;

public class tasks {

    String platFile ="platFile.csv";
    String storAdr = "storAdr.csv";

    //...........................................................................
    // FileFilter
    //...........................................................................

    public static void filtred(String inputFile, String outputFile)
    {

        String filterColumn = "plg_code_commune";
        int minValue = 75000;
        int maxValue = 75999;
        BufferedReader reader = null;
        BufferedWriter writer = null;

        try{
            reader = new BufferedReader(new FileReader(inputFile));
            writer = new BufferedWriter(new FileWriter(outputFile));
            String line;
            while ((line = reader.readLine()) != null)
            {
                String[] fields = line.split(";");
                String value = fields[10];
                if (isNumeric(value) && isBetween(Integer.parseInt(value), minValue, maxValue))
                {
                    line=fields[0]+";"+fields[1]+";"+fields[2]; // pour eliminer les champs Inutils
                    writer.write(line + "\n");
                }
            }
            System.out.println("Le fichier a été filtré avec succès !");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    private static boolean isNumeric(String str) {
        return str.matches("-?\\d+");
    }
    private static boolean isBetween(int value, int min, int max) {
        return value >= min && value <= max;
    }

    //...........................................................................
    // Les coordonnées XY d'une adresse de dossier sur storAdr
    //...........................................................................
    public String [] crdnXYLambert93StorAdr(String adresse)
    {

        String[] resultXY = new String[2];
        resultXY[0]="-111111111111111";
        resultXY[1]="-111111111111111";
        Boolean tr = false;
        BufferedReader reader = null;
        try {
            reader = new BufferedReader(new FileReader(storAdr));

            String ligne;
            int indexAdresse = 0;
            int indexX = 1;
            int indexY = 2;
            ligne = reader.readLine();
            while (!tr && ((ligne = reader.readLine()) != null))
            {
                String[] valeurs = ligne.split(";");
                //................................................
                int nbIndicesDepart = valeurs[0].length()-adresse.length()+1;
                for (int i = 0; i<nbIndicesDepart; i++)
                    if(valeurs[0].substring(i, i+adresse.length()).equalsIgnoreCase(adresse))
                    {
                        resultXY[0]=valeurs[1];
                        resultXY[1]=valeurs[2];
                        tr = true;
                        break;
                    }
            }

        } catch (IOException e) {
            System.out.println("StorAdr File not found");
            e.printStackTrace();
        }

        return resultXY;
    }
    //...........................................................................
    // Les coordonnées XY de SIRET redevable sur le fichier plat
    //...........................................................................
    public String [] crdnXYLambert93FichierPlat(String siret)
    {
        String siretForSearching =  siret.replaceAll("\\s+", ""); // blanc elimination
        String[] resultXY = new String[2];
        resultXY[0]="-99999999999999999";
        resultXY[1]="-99999999999999999";
        Boolean tr = false;
        try
        {
            BufferedReader reader = new BufferedReader(new FileReader(platFile));
            String ligne;
            int indexSiret = 0;
            int indexX = 1;
            int indexY = 2;
            ligne = reader.readLine();

            while (!tr && ((ligne = reader.readLine()) != null))
            {
                String[] valeurs = ligne.split(";");

                if(valeurs[0].startsWith(siretForSearching))   // in the flatFile is siret(14) but we search siren(9)
                {
                    resultXY[0]=valeurs[1];
                    resultXY[1]=valeurs[2];
                    tr = true;
                    break;
                }

            }
        }
        catch (IOException e) {
            System.out.println("PlatFile not found");
            e.printStackTrace();
        }
        return resultXY;
    }

    //...........................................................................
    //  Calcul de la distance
    //............................................................................

    public static double calculateDistance(double x1, double y1, double x2, double y2) {
        double distanceX = Math.pow(x2 - x1,2);
        double distanceY = Math.pow(y2 - y1,2);
        double distance = Math.sqrt(distanceX+distanceY);
        return distance;
    }
    //............................................................................
    // getSiretsUsingSiren
    //............................................................................
    public List<SiretXY> getSiretsUsingSiren(String siren, String[] xyStorAdr )
    {
        List<SiretXY> siretXYs = new ArrayList<SiretXY>();
        try
        {
            BufferedReader reader = new BufferedReader(new FileReader(platFile));
            String ligne;
            int indexSiret = 0;
            int indexX = 1;
            int indexY = 2;
            while ((ligne = reader.readLine()) != null)
            {
                String[] valeurs = ligne.split(";");
                //  System.out.println(valeurs[indexSiret].substring(valeurs[0].length() - 9));
                if (valeurs[indexSiret].startsWith(siren))
                {
                    SiretXY siret = new SiretXY();
                    siret.setSiret(valeurs[indexSiret]);
                    siret.setX(valeurs[indexX]);
                    siret.setY(valeurs[indexY]);
                    siret.setDistance(
                            calculateDistance(
                                    Double.parseDouble(xyStorAdr[0]),
                                    Double.parseDouble(xyStorAdr[1]),
                                    Double.parseDouble(valeurs[indexX]),
                                    Double.parseDouble(valeurs[indexY])));
                    siretXYs.add(siret);
                }
            }
        }
        catch (IOException e)
        {
            System.out.println("Filtred File not found");
            e.printStackTrace();
        }
        return siretXYs;
    }

}
